import { JSONfn } from './JSONfn';
export const defineWorker = (options = {}) => {
    self.onmessage = function (msg) {
        var request = JSON.parse(msg.data);
        var func = JSONfn.parse(request.func.body);
        var attachToContextFunctions = {};
        if (request.func.attachToContextFunctions && Object.keys(request.func.attachToContextFunctions).length > 0) {
            attachToContextFunctions = Object.keys(request.func.attachToContextFunctions).reduce((resultObject, keyFunction) => {
                resultObject[keyFunction] = JSONfn.parse(request.func.attachToContextFunctions[keyFunction]);
                return resultObject;
            }, {});
        }
        var result;
        if (func) {
            result = func({
                state: request.state,
                ...options?.imports,
                ...attachToContextFunctions,
                onProgressUpdate: (dataUpdate) => self.postMessage(JSON.stringify({ dataUpdate: dataUpdate ?? null, onProgressUpdate: true })),
            });
        }
        if (result) {
            result = JSON.stringify(result);
        }
        self.postMessage(result);
    };
};
//# sourceMappingURL=defineWorker.js.map